{---------------------------------------------------------------------------}
{ Bits&Bytes Program:  WALK1.PAS                                            }
{ DATE:         (See Version, below)                                        }
{ PROGRAMMER:   Terry King                                                  }
{ WHAT IT DOES: Example program using PARPORT.TPU for parallel port         }
{ HISTORY:                                                                  }
{ 03/11/97 - Initial release                                                }
{                                                                           }
{---------------------------------------------------------------------------}

{---------------------------------------------------------------------------}
{               U S E S :  External UNITS with needed functions             }
{---------------------------------------------------------------------------}

USES  dos, crt,   {Standard Borland TURBO units}
      ParPort;    {Parallel port I/O Support in PARPORT.TPU}

{---------------------------------------------------------------------------}
{               T Y P E S :                                                 }
{----------------------------------------------------------------------------}

{TYPE}                     {Uncomment if used}

{---------------------------------------------------------------------------}
{               C O N S T A N T S:                                          }
{---------------------------------------------------------------------------}
CONST

Version       = '1.000 [03/12/97: Walk1   Demo] Terry King '; {++Program version}

{-------( Digital IN Bits: What they are being used for:  )--- -------------}
{-------( NOTE: "In0" etc. are PLACEHOLDERS. YOU DECIDE what their NAME is---}
In0            =  0;      { Pin 10 on Parallel Port  SEE PARCABLE.TXT}
In1            =  1;      { Pin 11 on Parallel Port }
In2            =  2;      { Pin 12 on Parallel Port }
MySwitch       =  3;      { Pin 13 on Parallel Port }  {Example of NAMED bit}
In4            =  4;      { Pin 14 on Parallel Port }
In5            =  5;      { Pin 15 on Parallel Port }
In6            =  6;      { Pin 16 on Parallel Port }
In7            =  7;      { Pin 17 on Parallel Port }

{-------( Digital OUT Bits: What they are being used for:  )------  }
Out0        = 0;                                  { Pin 2  on Parallel Port }
Out1        = 1;                                  { Pin 3  on Parallel Port }
Out2        = 2;                                  { Pin 4  on Parallel Port }
Out3        = 3;                                  { Pin 5  on Parallel Port }
RedLED      = 4;                                  { Pin 6  on Parallel Port }
GreenLED    = 5;                                  { Pin 7  on Parallel Port }
IRBeam      = 6;                                  { Pin 8  on Parallel Port }
Beeper      = 7;                                  { Pin 9  on Parallel Port }


CHARCOLOR       = Yellow;   {Our screen colors}
BACKCOLOR       = Blue;

{---------------------------------------------------------------------------}
{               V A R I A B L E S:                                          }
{---------------------------------------------------------------------------}
VAR

{-----------------( SCALAR VARIABLES )----------------------------}
KbChar           : char;                    { for kbd input }

InputByte        : Byte;                    {Data read In/Out each SampleTime}
OutputByte       : Byte;
OutputByteInit   : Byte;                    {Startup time value}

n                : word;                    {general purpose}

SampleTime       : word;                    {Sample period (Ms)}

Samples          : Longint;                 {Samples of I/O }

Done             : Boolean;                 {End main loop when Done}


(*Ŀ
   INTERNAL PROCEDURES and FUNCTIONS                                       
  *)
{Would go here when/if you write them!!}

(*Ŀ
   MAIN PROGRAM:                                                           
  *)
BEGIN

  Done := FALSE;
  DioReset;

{---------( START OF PROGRAM )------------------------------------}

  ClrScr;
  Writeln(Version);
  Writeln('USING Parallel Port at Address= ', PortAddrString);
  Writeln;
  writeln('  Walking 1 DEMO: Blinks Output Bits. Needs Output cable, LEDs. ');
  writeln('    Hit <ESC> to Quit (Takes a few seconds)  ');

REPEAT

  OutputByte := $01;
  WriteDO(OutputByte);
  Writeln('Starting to walk a BIT up the LEDs');
  delay(500);
  FOR n := 1 to 7 DO
  BEGIN
    OutputByte := OutputByte SHL 1;
    WriteDO(OutputByte);
    delay(500);
  END;
  DioReset;
  delay(1500);

  if keypressed then if ( readkey = chr(27) ) then Done := TRUE;

UNTIL Done;


  {---------( END OF  PROGRAM )------------------------------------}

   WriteLn('************** Done: Exiting   ... Bye !! *************');
   delay(1000);    {So you can SEE it }
   Textmode(Co80);                        {Put the Display back to normal }
END.
